#!/usr/bin/env python

# Lines_Between_Paths Rel 1
# Created by Tin Tran http://bakon.ca/gimplearn/
# Comments directed to http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
import math
import string
#import Image
from gimpfu import *
from array import array
PRECISION = 0.0001
def python_lines_between_paths(image, layer, path1, path2, lineperdist) :
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	
	
	#PUT YOUR CODE HERE 
	#adds new path
		
	gimp.progress_init("Selecting area between paths...")
	added_paths = []
	
	newpath = pdb.gimp_vectors_new(image, "Lines")
	pdb.gimp_image_add_vectors(image, newpath, 0)
	pdb.gimp_item_set_visible(newpath,1)
	for i in range(len(path1.strokes)):
		
		stroke1 = path1.strokes[i]
		stroke2 = path2.strokes[i]
		
		length1 = stroke1.get_length(PRECISION);
		length2 = stroke2.get_length(PRECISION);
		loopcount = int(float(length1)/lineperdist)
		
		
		for section in range(0,(loopcount)+1):
			gimp.progress_update(float(section)/loopcount)
			dist1 = min(length1,section * lineperdist)
			dist2 = dist1/length1 * length2
			(x1,y1,slope1,valid) = stroke1.get_point_at_dist(dist1,PRECISION);
			(x2,y2,slope2,valid) = stroke2.get_point_at_dist(dist2,PRECISION);
			#if pdb.gimp_selection_value(image,x1,y1) > 0:
			strokePoints = ([x1,y1] * 3) + ([x2,y2] * 3)
			pdb.gimp_vectors_stroke_new_from_points(newpath,0, len(strokePoints),strokePoints,1)
	pdb.gimp_selection_none(image)
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_lines_between_paths",                           
	"Draws lines between paths",
	"Draws lines between paths...",
	"Tin Tran",
	"Tin Tran",
	"Nov 5, 2016",
	"<Image>/Python-Fu/Lines Between Paths",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_VECTORS, 'path1', 'Begin path', None),
	(PF_VECTORS, 'path2', 'End path', None),
	(PF_SPINNER, "lineperdist", "Line Per Distance (pixels):", 5, (1, 1000, 1)),
	],
	[],
	python_lines_between_paths)

main()
